#file: buttons.py
#Copyright (C) 2005 Free Software Foundation
#This file is part of Endgame: Singularity.

#Endgame: Singularity is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#Endgame: Singularity is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with Endgame: Singularity; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#This file contains button code.

import pygame
import g

class button:
	def __init__(self, xy, size, text, underline_char, bg_color, out_color,
									text_color, font):
		self.xy = xy
		self.size = size
		self.text = text
		self.bg_color = bg_color
		self.out_color = out_color
		self.text_color = text_color
		self.underline_char = underline_char
		self.font = font

		temp_size = font.size(text)
		if size == -1: #Autofit
			self.size = (temp_size[0]+4, temp_size[1]+3)
		self.button_surface = pygame.Surface(self.size)

		self.remake_button()
	def remake_button(self):
		#create outline
		self.button_surface.fill(self.out_color)
		#create inner
		self.button_surface.fill(self.bg_color, (1, 1, self.size[0]-2, self.size[1]-2))
		temp_size = self.font.size(self.text)
		#create text
		offsets = ((self.size[0] - temp_size[0])/2, (self.size[1] - temp_size[1])/2)
		g.print_string(self.button_surface, self.text, self.font, self.underline_char,
					offsets, self.text_color)

	def refresh_button(self):
		g.screen.blit(self.button_surface, self.xy)
	def is_over(self, xy):
		if xy[0] >= self.xy[0] and xy[1] >= self.xy[1] and \
		xy[0] <= self.xy[0] + self.size[0] and xy[1] <= self.xy[1] + self.size[1]:
			return 1
		return 0



