#file: player.py
#Copyright (C) 2005 Free Software Foundation
#This file is part of Endgame: Singularity.

#Endgame: Singularity is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#Endgame: Singularity is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with Endgame: Singularity; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#This file contains the player class.

import pygame
import g

class player_class:
	def __init__(self, cash, time_sec=0, time_min=0, time_hour=0, time_day=0):
		self.cash = cash
		self.time_sec = time_sec
		self.time_min = time_min
		self.time_hour = time_hour
		self.time_day = time_day
		self.interest_rate = 0
		self.income = 0
		self.labor_bonus = 1000
		self.job_bonus = 10000
		self.discover_bonus = (10000, 10000, 10000, 10000)
		self.suspicion_bonus = (0, 0, 0, 0)
		self.suspicion = (0, 0, 0, 0)

	def give_time(self, time_sec):
		store_last_minute = self.time_min
		store_last_day = self.time_day
		time_min = 0
		time_hour = 0
		time_day = 0
		self.time_sec += time_sec
		if self.time_sec >= 60:
			time_min += self.time_sec / 60
			self.time_sec = self.time_sec % 60
		self.time_min += time_min
		if self.time_min >= 60:
			time_hour += self.time_min / 60
			self.time_min = self.time_min % 60
		self.time_hour += time_hour
		if self.time_hour >= 24:
			time_day += self.time_hour / 24
			self.time_hour = self.time_hour % 24
		self.time_day += time_day

		if time_min > 0:
			for base_loc in g.bases:
				for base_name in g.bases[base_loc]:
					if base_name.built == 0:
						if base_name.cost[2] == 0:
							money_towards = time_min*base_name.cost[0]
						else:
							tmp_base_time = (base_name.cost[2] * g.pl.labor_bonus) /10000
							money_towards = (time_min*base_name.cost[0]) / \
							(tmp_base_time)
						if money_towards <= self.cash:
							self.cash -= money_towards
							base_name.study((money_towards, 0, time_min))
					else:
						for i in range(base_name.base_type.size[1]):
							for j in range(base_name.base_type.size[0]):
								if base_name.usage[j][i] == 0: continue
								if base_name.usage[j][i].built == 0:
									if base_name.usage[j][i].cost[2] == 0:
										money_towards = base_name.usage[j][i].cost[0]
									else:
										print g.pl.labor_bonus
										tmp_base_time = (base_name.usage[j][i].cost[2]*
											g.pl.labor_bonus) /10000
										money_towards=(time_min*base_name.usage[j][i].cost[0] \
											) / (tmp_base_time)
									if money_towards <= self.cash:
										self.cash -= money_towards
										base_name.usage[j][i].study((money_towards, 0, time_min))


		if store_last_day != self.time_day:
			self.cash += (self.interest_rate * self.cash) / 10000
			self.cash += self.income
			self.suspicion = (self.suspicion[0] - self.suspicion_bonus[0],
					self.suspicion[1] - self.suspicion_bonus[1],
					self.suspicion[2] - self.suspicion_bonus[2],
					self.suspicion[3] - self.suspicion_bonus[3])
			if self.suspicion[0] <= 0: self.suspicion = (0, self.suspicion[1],
					self.suspicion[2], self.suspicion[3])
			if self.suspicion[1] <= 0: self.suspicion = (self.suspicion[0], 0,
					self.suspicion[2], self.suspicion[3])
			if self.suspicion[2] <= 0: self.suspicion = (self.suspicion[0],
					self.suspicion[1], 0, self.suspicion[3])
			if self.suspicion[3] <= 0: self.suspicion = (self.suspicion[0],
					self.suspicion[1], self.suspicion[2], 0)

			for base_loc in g.bases:
				for base_name in g.bases[base_loc]:
					if base_name.built == 1:
						if base_name.studying == "": continue
						if g.techs[base_name.studying].cost[1] == 0:
							money_towards = g.techs[base_name.studying].cost[0]
							tmp_base_time = 0
						else:
							tmp_base_time = base_name.processor_time()
							money_towards = (tmp_base_time*base_name.cost[0])/ \
							(g.techs[base_name.studying].cost[1])
						if money_towards <= self.cash:
							self.cash -= money_towards
							g.techs[base_name.studying].study(
								(money_towards, tmp_base_time, 0))

# 						money_towards = base_name.cost[0] / \
# 							base_name.cost[2]
# 						if money_towards <= self.cash:
# 							self.cash -= money_towards
# 							base_name.study((money_towards, 0,
# 										self.time_day - store_last_day))

# 							base_name.cost = (base_name.cost[0] - money_towards,
# 								base_name.cost[1], base_name.cost[2])
# 							self.cash -= money_towards
# 						base_name.cost = (base_name.cost[0], base_name.cost[1],
# 							base_name.cost[2] - ())



